﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=8.8
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
#End Region

Sub Process_Globals
	Private jobs As Map
	Private timer1 As Timer
	Type DownloadData (url As String, Target As Object, EventName As String)
	Type JobTag (Data As DownloadData, CountingStream As CountingOutputStream, Total As Long)
	Private pw As PhoneWakeState

	Dim notif As Notification
	Dim n As NB6
	Private smiley As Bitmap
End Sub

Sub Service_Create
	jobs.Initialize
	timer1.Initialize("timer1", 1000)
End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub

Sub Service_Destroy

End Sub

Private Sub StartTimer (Target As Object)
'	n.Initialize
'	n.Icon = "icon"
'	n.Vibrate = False
'	n.Sound = False
'	n.Light = False
'	n.SetInfo("Downloading file...", "",Target)
	'
'	
'	NotificationProgress(Starter.currentProgress)
	
	Notification(0,"","")
	
	Service.StartForeground(1, notif)
	timer1.Enabled = True
	pw.PartialLock
	
End Sub


Sub Notification(per As Int, Title As String, SubTitle As String)
	smiley = LoadBitmapResize(File.DirAssets, "icon.png", 24dip, 24dip, False)
	n.Initialize("default", Application.LabelName, "DEFAULT").SmallIcon(smiley)
	n.Progress(per, 100, False)
	n.OnlyAlertOnce(True)
	notif = n.Build(Title, SubTitle, "tag", Me)
	notif.Notify(1)
End Sub


Private Sub EndTimer
	Service.StopForeground(1)
	timer1.Enabled = False
	pw.ReleasePartialLock
End Sub

Public Sub StartDownload(data As DownloadData)
	If jobs.ContainsKey(data.url) Then
		Log("Ignoring duplicate request.")
		Return
	End If
	Dim J As HttpJob
	J.Initialize(data.url, Me)
	Dim tag As JobTag
	tag.Initialize
	tag.data = data
	J.tag = tag
	jobs.Put(data.url, J)
	J.Download(data.url)
	If timer1.Enabled = False Then StartTimer(data.Target)
End Sub

Public Sub CancelDownload(url As String)
	If jobs.ContainsKey(url) = False Then
		Log("Ignoring cancel request.")
		Return
	End If
	Dim job As HttpJob = jobs.Get(url)
	Dim jt As JobTag = job.Tag
	If jt.CountingStream.IsInitialized Then
		jt.CountingStream.Close
	Else
		jt.Data.url = ""
	End If
	
	CancelNotification
End Sub

Sub timer1_tick
	For Each job As HttpJob In jobs.Values
		Dim jt As JobTag = job.Tag
		If jt.CountingStream.IsInitialized Then
			CallSub3(jt.Data.Target, jt.Data.EventName & "_Progress", jt.CountingStream.Count, jt.Total)
			
			Dim Data As String = NumberFormat(jt.CountingStream.Count / 1048576, 1, 2) & "MB / " & NumberFormat(jt.Total / 1048576, 1, 2) & "MB"
'			Notification(Starter.currentProgress,"Awtar Downloading...",Data)
		End If
	Next

	
End Sub

Sub JobDone(job As HttpJob)
	jobs.Remove(job.JobName)
	Dim jt As JobTag = job.Tag
	If jobs.Size = 0 Then EndTimer
	If job.Success Then
		CallSubDelayed3(jt.Data.Target, jt.Data.EventName & "_Progress", jt.CountingStream.Count, jt.Total)
		CallSubDelayed2(jt.Data.Target, jt.Data.EventName & "_Complete", job)
				
	Else
		Log(job.ErrorMessage)
		CallSubDelayed2(jt.Data.Target, jt.Data.EventName & "_Complete", job)
	End If
	
	CancelNotification
End Sub

Sub CancelNotification
	notif.Cancel(1)
	notif.Cancel(6)
End Sub